package cn.estsh.i3plus.pojo.platform.sqlpack;

import cn.estsh.i3plus.pojo.base.tool.HqlPack;
import cn.estsh.i3plus.pojo.platform.bean.*;

import java.util.Arrays;

/**
 * @Description : 平台对象封装
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-10-23 21:15
 * @Modify:
 **/
public class CoreHqlPack {

    /**
     * 资源查询
     * @param sysLocaleResource
     * @return
     */
    public static String packHqlSysLocaleResource(SysLocaleResource sysLocaleResource){
        StringBuffer result = new StringBuffer();

        //查询日期
        HqlPack.timeBuilder(sysLocaleResource.getCreateDateTimeStart(),sysLocaleResource.getCreateDateTimeEnd(),
                "createDateTime", result, false);
        //数字类型封装
        HqlPack.getNumEqualPack(sysLocaleResource.getResourceType(),"resourceType",result);
        //字符串类型封装
        HqlPack.getStringEqualPack(sysLocaleResource.getLanguageCode(),"languageCode",result);

        return result.toString();
    }

    /**
     * 语言
     * @param lang
     * @return
     */
    public static String packHqlSysLocaleLanguage(SysLocaleLanguage lang) {
        StringBuffer result = new StringBuffer();

        //查询日期
        HqlPack.timeBuilder(lang.getCreateDateTimeStart(),lang.getCreateDateTimeEnd(),
                "createDateTime", result, false);
        //数字类型封装
        HqlPack.getNumEqualPack(lang.getLanguageCode(),"languageCode",result);
        //字符串类型封装
        HqlPack.getStringEqualPack(lang.getLanguageName(),"languageName",result);

        return result.toString();
    }

    /**
     * 岗位复杂查询
     * @param position
     * @return
     */
    public static String packHqlDepartment(Position position) {
        StringBuffer result = new StringBuffer();

        // 岗位名称
        HqlPack.getStringLikerPack(position.getName(),"positionName",result);
        // 岗位代码
        HqlPack.getStringLikerPack(position.getPositionCode(),"positionCode",result);
        // 父级岗位
        HqlPack.getNumEqualPack(position.getId(),"parentId",result);

        return result.toString();
    }

    /**
     * In 参数封装
     * @param columnName
     * @return
     */
    public static String packHqlIds(String columnName,String[] params){
        StringBuffer result =  new StringBuffer();

        // 参数数组 [1,2,3] -> "1,2,3"
        HqlPack.getInPack(String.join(",",params),columnName,result);
        return result.toString();
    }

    /**
     * 部门复杂查询
     * @param department
     * @return
     */
    public static String packHqlDepartment(Department department) {
        StringBuffer result = new StringBuffer();

        // 部门名称
        HqlPack.getStringLikerPack(department.getName(),"positionName",result);
        // 部门代码
        HqlPack.getStringLikerPack(department.getDepartmentCode(),"positionCode",result);
        // 父级部门id
        HqlPack.getNumEqualPack(department.getId(),"parentId",result);
        // 所属组织id
        HqlPack.getNumEqualPack(department.getOrganizeId(),"organizeId",result);

        return result.toString();
    }

    /**
     * 岗位复杂查询
     * @param position
     * @return
     */
    public static String packHqlPosition(Position position){
        StringBuffer result = new StringBuffer();

        // 查询参数封装
        HqlPack.getNumEqualPack(position.getParentId(),"parentId",result);
        HqlPack.getStringLikerPack(position.getName(),"name",result);
        HqlPack.getStringLikerPack(position.getPositionCode(),"positionCode",result);

        return result.toString();
    }

    /**
     * 系统参数复杂查询
     * @param sysConfig
     * @return
     */
    public static String packHqlSysConfig(SysConfig sysConfig) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(sysConfig.getName(),"name",result);
        HqlPack.getStringLikerPack(sysConfig.getConfigCode(),"configCode",result);
        HqlPack.getNumEqualPack(sysConfig.getConfigTypeId(),"configTypeId",result);

        return result.toString();
    }

    /**
     * 字典信息复杂查询
     * @param sysDictionary
     * @return
     */
    public static String packHqlSysDictionary(SysDictionary sysDictionary) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(sysDictionary.getName(),"name",result);
        HqlPack.getStringLikerPack(sysDictionary.getDictionaryCode(),"dictionaryCode",result);
        HqlPack.getNumEqualPack(sysDictionary.getParentId(),"parentId",result);

        return result.toString();
    }

    /**
     * 硬件类型复杂查询
     * @param toolType
     * @return
     */
    public static String packHqlToolType(ToolType toolType) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(toolType.getName(),"name",result);

        return result.toString();
    }
}
